//****************************************************************************
//Copyright (C) 2005-2006 Beijing BlueDJ Technology Co.,Ltd. All rights reserved.

//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program (in the file LICENSE.GPL); if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

//Please visit http://www.bluedj.com for more infomation about us.
//Contact us at ggwizard@gmail.com or darkdong@gmail.com.
//****************************************************************************/

#ifndef DJMATRIXCANVASIMAGE_H
#define DJMATRIXCANVASIMAGE_H

#include <QtGui>
#include <Qt3Support>
#include "DJBaseGlobal.h"

class DJ_BASE_EXPORT DJMatrixCanvasImage: public Q3CanvasRectangle
{
public:
	static const int RTTI;
	DJMatrixCanvasImage( Q3Canvas *canvas, const QPixmap& pix = QPixmap(), int type = 0, quint32 id = 0 );
	virtual ~DJMatrixCanvasImage();
	
	virtual int rtti() const;
	int	type() const { return m_type; }
	quint32	id() const { return m_id; }
	QPixmap	originalPixmap() const { return m_originalPixmap; }
	void setOriginalPixmap( const QPixmap& pix );
	QPixmap	pixmap() const { return m_pixmap; }
	Qt::Alignment alignment() const { return m_alignment; }
	void setAlignment( Qt::Alignment align );
	void setInnerMatrix( const QMatrix& matrix );
	void setExternalMatrix( const QMatrix& matrix );
	QSize realSize() const;
	void matrimove( double x, double y );
	void move( double x, double y );
protected:
    virtual void drawShape( QPainter & );
private:
	void initWithPixmap( const QPixmap& pix );
	
	QPixmap m_originalPixmap,m_pixmap;
    int	m_type;
    quint32	m_id;
    
    QMatrix	m_externalMatrix,m_innerMatrix;
    double	m_x,m_y;
    Qt::Alignment		m_alignment;
};
#endif
